// ATtiny1614
/* Driver 1
   PA4 - 0
   PA5 - 1
   PA6 - 2
   PA7 - 3

   Driver 2
   PA2 - 9
   PA3 - 10
   PB2 - 5
   PB3 - 4
   
   PA1(LED) - 8
   PB0(IR Sensor) - 7
   PB1 (Extra- 6 */

#define led 8

#define MA1p 2  //Motor A1
#define MA1n 3

#define MA2p 0  //Motor A2
#define MA2n 1 

#define MB1p 9  //Motor B1
#define MB1n 10

#define MB2p 7  //Motor B2
#define MB2n 6

const int dlyTime = 1000;
void setup() {
  pinMode(led, OUTPUT);

  pinMode(MA1p, OUTPUT);  // Front Left Motor
  pinMode(MA1n, OUTPUT);
  
  pinMode(MA2p, OUTPUT);  // Front Right Motor
  pinMode(MA2n, OUTPUT);
  
  pinMode(MB1p, OUTPUT);  // Rear Left Motor
  pinMode(MB1n, OUTPUT);
  
  pinMode(MB2p, OUTPUT);  // Rear Right Motor
  pinMode(MB2n, OUTPUT);

  Serial.begin(9600);
}
void loop() {
  //delay(dlyTime);
  delay(1500);
  digitalWrite(led, HIGH);
  MA1cw();    //FORWARD
  MB1cw();
  MA2cw();
  MB2cw();
  delay(1500);
  
  MA1stop();
  MB1stop();
  MA2stop();
  MB2stop();
  delay(1000);
  
  MA1cw();    //RIGHT
  MB1ccw();
  MA2ccw();
  MB2cw();
  delay(1500);

  MA1stop();
  MB1stop();
  MA2stop();
  MB2stop();
  delay(1000);
  
  digitalWrite(led, LOW);
  MA1ccw();   //BACKWARD
  MB1ccw();
  MA2ccw();
  MB2ccw();
  delay(1500);

  MA1stop();
  MB1stop();
  MA2stop();
  MB2stop();
  delay(1000);
  
  MA1ccw();   //LEFT
  MB1cw();
  MA2cw();
  MB2ccw();
  delay(1500);

  MA1stop();
  MB1stop();
  MA2stop();
  MB2stop();
  delay(1000);
  
  MA1stop();    // Forward Diagonal Left
  MB1cw();
  MA2cw();
  MB2stop();
  delay(1500);

  MA1stop();
  MB1stop();
  MA2stop();
  MB2stop();
  delay(1000);

  MA1cw();    // Forward Diagonal Right
  MB1stop();
  MA2stop();
  MB2cw();
  delay(1500);
  
  MA1stop();
  MB1stop();
  MA2stop();
  MB2stop();
  delay(1000);

  MA1stop();    // Backward Diagonal Right
  MB1ccw();
  MA2ccw();
  MB2stop();
  delay(1500);

  MA1stop();
  MB1stop();
  MA2stop();
  MB2stop();
  delay(1000);

  MA1ccw();   // Backward Diagonal Left
  MB1stop();
  MA2stop();
  MB2ccw();
  delay(1500);
  
  MA1stop();
  MB1stop();
  MA2stop();
  MB2stop();
  delay(1000);

  MA1cw();    // Clockwise
  MB1cw();
  MA2ccw();
  MB2ccw();
  delay(2000);

  MA1stop();
  MB1stop();
  MA2stop();
  MB2stop();
  delay(1000);

  MA1ccw();     // Counter Clockwise
  MB1ccw();
  MA2cw();
  MB2cw();
  delay(2000);

  MA1stop();
  MB1stop();
  MA2stop();
  MB2stop();
  delay(1000);
}

void MA1cw(){
  digitalWrite(MA1p, HIGH);
  delay(10);
  digitalWrite(MA1n, LOW);
}
void MA1ccw(){
  digitalWrite(MA1p, LOW);
  delay(10);
  digitalWrite(MA1n, HIGH);
}
void MA1stop(){
  digitalWrite(MA1p, LOW);
  digitalWrite(MA1n, LOW);
  delay(10);
}

void MA2cw(){
  digitalWrite(MA2p, HIGH);
  delay(10);
  digitalWrite(MA2n, LOW);
}
void MA2ccw(){
  digitalWrite(MA2p, LOW);
  delay(10);
  digitalWrite(MA2n, HIGH);
}
void MA2stop(){
  digitalWrite(MA2p, LOW);
  digitalWrite(MA2n, LOW);
  delay(10);
}

void MB1cw(){
  digitalWrite(MB1p, HIGH);
  delay(10);
  digitalWrite(MB1n, LOW);
}
void MB1ccw(){
  digitalWrite(MB1p, LOW);
  delay(10);
  digitalWrite(MB1n, HIGH);
}
void MB1stop(){
  digitalWrite(MB1p, LOW);
  digitalWrite(MB1n, LOW);
  delay(10);
}

void MB2cw(){
  digitalWrite(MB2p, HIGH);
  delay(10);
  digitalWrite(MB2n, LOW);
}
void MB2ccw(){
  digitalWrite(MB2p, LOW);
  delay(10);
  digitalWrite(MB2n, HIGH);
}
void MB2stop(){
  digitalWrite(MB2p, LOW);
  digitalWrite(MB2n, LOW);
  delay(10);
}
